=== debian/changelog ===
fastnetmon (1.2.7-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 15 Jul 2024 11:11:33 +0200

fastnetmon (1.2.7-1) unstable; urgency=medium

  * New upstream release.
  * Use new systemd service: Create a fastnetmon user and do not run fastnetmon
    as root anymore.
  * Update debian/copyright.
  * Overwrite false positive lintian warning.
  * Use dh-sequence-movetousr build dependency to move files to /usr.
    Closes: #1073746
  * Bump Standards-Version to 4.7.0.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 08 Jul 2024 15:49:50 +0200
