=== debian/changelog ===
fastnetmon (1.2.8-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 06 Mar 2025 10:10:06 +0100

fastnetmon (1.2.8-1) unstable; urgency=high

  * New upstream release.
    - Fixes CVE-2024-56073: Zero-length templates for Netflow v9 allow remote
      attackers to cause a denial of service (divide-by-zero error and
      application crash).
      Closes: #1090387
    - Fixes CVE-2024-56072: The sFlow v5 plugin allows remote attackers to cause
      a denial of service (application crash) via a crafted packet that
      specifies many sFlow samples.
      Closes: #1090388
  * Use pkgconf build dependency.
  * Add patch 01-spelling-error.
  * Adjust lintian overrides.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 23 Dec 2024 09:51:10 +0100
