=== debian/control ===
Source: fastnetmon
Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Section: net
Priority: optional
Standards-Version: 4.7.0
Rules-Requires-Root: no
Build-Depends: cmake,
 debhelper-compat (= 13),
 dh-sequence-movetousr,
 libboost-atomic-dev,
 libboost-chrono-dev,
 libboost-date-time-dev,
 libboost-program-options-dev,
 libboost-regex-dev,
 libboost-system-dev,
 libboost-thread-dev,
 libbpf-dev,
 libelf-dev,
 libbson-dev,
 libcapnp-dev,
 libgrpc-dev,
 libgrpc++-dev,
 libprotobuf-dev,
 protobuf-compiler,
 protobuf-compiler-grpc,
 capnproto,
 golang-github-osrg-gobgp-dev,
 libhiredis-dev,
 liblog4cpp5-dev,
 libicu-dev,
 libmongoc-dev,
 libncurses-dev,
 libpcap-dev,
 pkgconf
Homepage: https://fastnetmon.com/
Vcs-Browser: https://salsa.debian.org/debian/fastnetmon
Vcs-Git: https://salsa.debian.org/debian/fastnetmon.git

Package: fastnetmon
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 ${shlibs:Depends},
 adduser
Description: fast DDoS analyzer with sflow/netflow/mirror support (community edition)
 FastNetMon is a very high performance distributed denial-of-service attack
 (DDoS attack) detector built on top of multiple packet capture engines:
 NetFlow, IPFIX, sFLOW.
 .
 It can detect hosts in your networks sending or receiving large volumes of
 packets/bytes/flows per second. It can call an external script to notify you,
 switch off a server, or blackhole the client.
 .
 To enable sFLOW, simply specify IP of the server running FastNetMon and specify
 (configurable) port 6343. To enable netflow, simply specify IP of the server
 running FastNetMon and specify (configurable) port 2055.
 .
 This package contains the community edition.
