## fastnetmon 1.2.8+git20250911

=== src/packaging/FreeBSD/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 MAINTAINER=	farrokhi@FreeBSD.org
 COMMENT=	Very fast DDoS analyzer with sflow/netflow/mirror support
-WWW=		https://fastnetmon.com
+WWW=		https://github.com/pavel-odintsov/fastnetmon
 
 LICENSE=	GPLv2
 LICENSE_FILE=	${WRKSRC}/LICENSE
