=== debian/changelog ===
fastnetmon (1.2.8+git20250911-2) unstable; urgency=medium

  * Bump Standards-Version to 4.7.3 (Remove priority field).
  * Remove dh_movetousr sequence and manually set the systemd servicedir.
    Closes: #1122752
  * Update years in debian/copyright.
  * Remove Rules-Requires-Root control field.
  * Update debian/watch to version 5.
  * Remove libboost-system-dev Build-Depends.
    Closes: #1127190

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 10 Feb 2026 16:12:15 +0100

fastnetmon (1.2.8+git20250911-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Fixes build with mongo-c-driver 2.0.
      Closes: #1111777, #1110574, #1112881
    - Remove merged patch 01-spelling-error.
  * Bump Standards-Version to 4.7.2.
  * Merge 1.2.4-2+deb12u1 changelog.
  * Fix old-fsf-address-in-copyright-file.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 11 Sep 2025 15:48:36 +0200
