=== debian/control ===
--- 
+++ 
@@ -1,18 +1,14 @@
 Source: fastnetmon
 Maintainer: Patrick Matthäi <pmatthaei@debian.org>
 Section: net
-Priority: optional
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Build-Depends: cmake,
  debhelper-compat (= 13),
- dh-sequence-movetousr,
  libboost-atomic-dev,
  libboost-chrono-dev,
  libboost-date-time-dev,
  libboost-program-options-dev,
  libboost-regex-dev,
- libboost-system-dev,
  libboost-thread-dev,
  libbpf-dev,
  libelf-dev,
