=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq (,$(filter-out mips mipsel m68k powerpc powerpcspe sh4,$(DEB_HOST_ARCH)))
EXTRA_ARGS += -DUSE_NEW_ATOMIC_BUILTINS=ON
endif

%:
	dh $@ --buildsystem=cmake --sourcedirectory=src

override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_CUSTOM_BOOST_BUILD=FALSE \
		-DDO_NOT_USE_SYSTEM_LIBRARIES_FOR_BUILD=FALSE \
		-DLINK_WITH_ABSL=TRUE \
		-DCMAKE_INSTALL_SYSTEMD_SERVICEDIR=/usr/lib/systemd/system \
		$(EXTRA_ARGS)

override_dh_installsystemd:
	dh_installsystemd --no-start --no-enable --restart-after-upgrade
